#include "fdf.h"

void	mat4_translate(t_mat4 *m, double x, double y, double z)
{
	m->mx[0][0] = 1;
	m->mx[0][1] = 0;
	m->mx[0][2] = 0;
	m->mx[0][3] = 0;
	m->mx[1][0] = 0;
	m->mx[1][1] = 1;
	m->mx[1][2] = 0;
	m->mx[1][3] = 0;
	m->mx[2][0] = 0;
	m->mx[2][1] = 0;
	m->mx[2][2] = 1;
	m->mx[2][3] = 0;
	m->mx[3][0] = x;
	m->mx[3][1] = y;
	m->mx[3][2] = z;
	m->mx[3][3] = 1;
}

void	mat4_scale(t_mat4 *m, double x, double y, double z)
{
	m->mx[0][0] = x;
	m->mx[0][1] = 0;
	m->mx[0][2] = 0;
	m->mx[0][3] = 0;
	m->mx[1][0] = 0;
	m->mx[1][1] = y;
	m->mx[1][2] = 0;
	m->mx[1][3] = 0;
	m->mx[2][0] = 0;
	m->mx[2][1] = 0;
	m->mx[2][2] = z;
	m->mx[2][3] = 0;
	m->mx[3][0] = 0;
	m->mx[3][1] = 0;
	m->mx[3][2] = 0;
	m->mx[3][3] = 1;
}

void	mat4_z_rot(t_mat4 *m, double angle)
{
	angle = angle * M_PI / 180;
	m->mx[0][0] = cos(angle);
	m->mx[0][1] = -(sin(angle));
	m->mx[0][2] = 0;
	m->mx[0][3] = 0;
	m->mx[1][0] = sin(angle);
	m->mx[1][1] = cos(angle);
	m->mx[1][2] = 0;
	m->mx[1][3] = 0;
	m->mx[2][0] = 0;
	m->mx[2][1] = 0;
	m->mx[2][2] = 1;
	m->mx[2][3] = 0;
	m->mx[3][0] = 0;
	m->mx[3][1] = 0;
	m->mx[3][2] = 0;
	m->mx[3][3] = 1;
}

void	mat4_x_rot(t_mat4 *m, double angle)
{
	angle = angle * M_PI / 180;
	m->mx[0][0] = 1;
	m->mx[0][1] = 0;
	m->mx[0][2] = 0;
	m->mx[0][3] = 0;
	m->mx[1][0] = 0;
	m->mx[1][1] = cos(angle);
	m->mx[1][2] = (sin(angle));
	m->mx[1][3] = 0;
	m->mx[2][0] = 0;
	m->mx[2][1] = -sin(angle);
	m->mx[2][2] = cos(angle);
	m->mx[2][3] = 0;
	m->mx[3][0] = 0;
	m->mx[3][1] = 0;
	m->mx[3][2] = 0;
	m->mx[3][3] = 1;
}

void	mat4_y_rot(t_mat4 *m, double angle)
{
	angle = angle * M_PI / 180;
	m->mx[0][0] = cos(angle);
	m->mx[0][1] = 0;
	m->mx[0][2] = -(sin(angle));
	m->mx[0][3] = 0;
	m->mx[1][0] = 0;
	m->mx[1][1] = 1;
	m->mx[1][2] = 0;
	m->mx[1][3] = 0;
	m->mx[2][0] = sin(angle);
	m->mx[2][1] = 0;
	m->mx[2][2] = cos(angle);
	m->mx[2][3] = 0;
	m->mx[3][0] = 0;
	m->mx[3][1] = 0;
	m->mx[3][2] = 0;
	m->mx[3][3] = 1;
}